// Matrix.java    

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

/**
 * This is the class for matrixes and vectors.
 * 
 * 
 *
 * @author Marco Agagliate 
 *  
 */
public class Matrix extends SwarmObjectImpl
        {
        /** This is a vector of double */ 
        public double[] vect;
        /** This is a matrix of double */
        public double[][] matr;
 
        /** Constructors for a new Matrix. */
        public Matrix(Zone aZone, int rows)
                {
                super(aZone);
                vect = new double[rows];
                }
        public Matrix(Zone aZone, int rows, int cols)
                {
                super(aZone);
                matr = new double[rows][cols];
                }
 
        /** This method sets a double in a position of the vector. */
        public void P$setFrom(int rows, double x)
                {
                vect[rows] = x;
                }

        /** This method returns a double from a position of the vector. */
        public double P(int rows)
                {
                return vect[rows];
                } 

        public int getLength(){
                return vect.length;
                }          

        /** This method sets a double in a position of the matrix. */
        public void R$C$setFrom(int rows, int cols, double x)
                {
                matr[rows][cols] = x;
                }

        /** This method returns a double from a position of the matrix. */
        public double R$C(int rows, int cols)
                {
                return matr[rows][cols];
                }
        }
 

